#include <iostream>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <iterator>
#include <string>
#include <cmath>

void createDataFileStreams(const std::string& file) {
	srand(time(NULL));
	std::ofstream f (file, std::ios::out | std::ios::trunc);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	for (int i = 0; i < 100; ++i) {			
		f << rand() % 101 - 50 << "\n";
	}
	f.close();	
}

void createDataGenerateCopy(const std::string& file) {
	srand(time(NULL));
	std::ofstream f(file, std::ios::out | std::ios::trunc);
	std::vector<int> values(100);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	std::generate(values.begin(), values.end(), []() { 
			return (std::rand() % 101 - 50); 
		});	
	std::copy(values.begin(), values.end(), std::ostream_iterator<int>(f, "\n"));
	f.close();
}

template<class container>
container loadDataFileStream(const std::string& file) {
	container res;
	std::ifstream f(file);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	int buf;
	while (f >> buf) {
		res.push_back(buf);
	}
	fin.close();
	return res;
}


template<class container>
container loadDataIterCopy(const std::string& file) {
	container res;
	std::ifstream f(file);
	if (!f.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), res.begin());
	return res;
}

template<class container>
void modifyCont(container& cont) {
	int sum = 0;
	for (const auto& i : cont) {
		sum += std::abs(i);
	}
	double mean = sum / 100;
	for (auto& i : cont) {
		if cont[i] == 0 {
			cont[i] = mean;
		}
	}
	cont.push_back(sum);
	cont.push_back(mean);
}

template<class iterator>
void modifyIters(iterator begin, iterator end) {
	std::vector<int> values(begin, end);
	int sum = 0;
	for (auto iter = beg; iter != end; ++iter) {
		sum += std::abs(*iter);
	}
	double mean = sum / 100;
	for (auto& iter = beg; iter != end; ++iter) {
		if (*iter == 0) {
			*iter = mean;
		}
	}
}

template<class container>
void modifyForEach(container& cont) {
	int sum = 0;
	std::for_each(cont.begin(), cont.end(), [&sum](const auto& obj) {
			sum += std::abs(obj);
		});
	double mean = sum / 100;
	std::for_each(cont.begin(), cont.end(), [&sum](auto& obj) {
			if (obj == 0) {
				obj = mean;
			}
		});
}

void modifyTransform(const std::string& file) {
	std::vector<int> buf(100);
	std::ifstream fin(file);
	if (!fin.is_open()) {
		throw std::exception("FILE NOT EXIST");
	}
	std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), buf.begin());
	int sum = 0;
	std::for_each(buf.begin(), buf.end(), [&sum](const auto& obj) {
			sum += obj; 
		});
	double mean = sum / 100;
	std::ofstream fout("result.txt");
	std::transform(buf.begin(), buf.end(), std::ostream_iterator<int>(fout, "\n"), [&sum](auto& obj) { 
			return obj = mean; 
		});
}
